--toma el dictado y al momento de pegarlo lo pega ya traducido al inglés,
require "import"
import "android.speech.SpeechRecognizer"
import "android.speech.RecognitionListener"
import "android.speech.RecognizerIntent"
import "java.util.Locale"
import "android.content.Intent"

require "import"
import "com.androlua.*"
import "java.util.Locale"
import "android.net.Uri"
import "android.text.Html"
local translationResult = "" -- Variable para almacenar el resultado de la traducción

function capWords(str)
    return str:gsub("(%S+)", function(word)
        return word:gsub("%a", string.upper, 1)
    end)
end

function addPunctuation(text)
    local lastChar = text:sub(-1)
    local punctuation = { ".", "!", "?" }
    local hasPunctuation = false

    for _, p in ipairs(punctuation) do
        if lastChar == p then
            hasPunctuation = true
            break
        end
    end

    if not hasPunctuation then
        text = text .. "."
    end

    return text
end

function kill()
    speechRecognizer.destroy()
    speechRecognizer = nil
    return true
end

function startListening()
    speechRecognizer = SpeechRecognizer.createSpeechRecognizer(this)
    speechListener = RecognitionListener{
        onResults = function(results)
            data = results.getParcelableArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
            if data ~= nil and data.size() > 0 then
                local originalText = capWords(data.get(0))
                translateText(originalText)
            end
            kill()
        end,
        onError = function()
            kill()
            startListening()
        end
    }
    recognizerIntent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
    recognizerIntent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
    recognizerIntent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, Locale.getDefault())
    recognizerIntent.putExtra(RecognizerIntent.EXTRA_CALLING_PACKAGE, this.getPackageName())
    speechRecognizer.startListening(recognizerIntent)
    speechRecognizer.setRecognitionListener(speechListener)
end

function translateText(text)
url = "https://translate.google.com/m?sl=id&tl=ar&hl="..Locale.getDefault().getLanguage().."&q="..Uri.encode(text)

    Http.get(url, function(status, result)
        if status == 200 then
            local translation = tostring(Html.fromHtml(result:match('<div class="result%-container">([^<]+)</div>')))
            translationResult = translationResult .. translation -- Concatenar el resultado de la traducción al string existente
            translationResult = addPunctuation(translationResult) -- Agregar signo de puntuación si es necesario
            service.paste(translationResult.."\n")
            service.speak(" "..translationResult)
        else
            print("Error :-(")
        end
    end)
end

startListening()